<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

Example(title='Toggle Param Example' :maxState="1")
  template(v-slot:description)
    h5 This is a simple Toggle Switch
    p Click on the #[em animate] to toggle edit mode.
    p Click on #[em code] to view and modify its code.

  template(v-slot:interface)
    h4 Interface of BaseToggle
    div #[strong Properties:]
      ul
        +prop("value") the toggle current live value
        +prop("label") the label on the right of the toggle
        +prop("disabled") to activate disabled mode
        +prop("inEdit") enter/exit edit mode

    div #[strong Data:]
      ul
        +prop("editValue") edit mode currently selected value

    div #[strong Signals:]
      ul
        +prop("edit") emitted whenever editValue is changed (with editValue new content)
        +prop("userEdit") emitted whenever the toggle is clicked (with editValue content)

    h4.mt-2 Interface of BaseParamToggle
    div #[strong Properties:]
      ul
        +prop("title") the Param title
        +prop("value") the Param current live value
        +prop("inEdit") enter/exit edit mode

    div #[strong Data:]
      ul
        +prop("editValue") edit mode currently selected value

    div #[strong Signals:]
      ul
        +prop("edit") emitted whenever editValue is changed (with editValue new content)
        +prop("edit-request") emitted whenever the icon on the right is clicked while not in edit mode

    div #[strong Slots:]
      ul
        +prop("title") To change  the content of card title
        +prop("trueIcon") Custom content when value is true (not in edit mode)
        +prop("falseIcon") Custom content when value is false (not in edit mode)


  template(v-slot:code)
    template(v-pre).
      div
        .row.justify-content-center.align-items-center.mb-2
          .col-12.col-sm-6
            BaseToggle(:value='false' :inEdit='state !== 0' label="This is a custom toggle switch")
          .col-12.col-sm-6
            BaseToggle(:value='false' :inEdit='state !== 0'
                       @edit-request='state = state ? 0 : 1')
              template(#label='toggle')
                template(v-if='toggle.inEdit') This switch is {{ toggle.editValue ? "enabled" : "disabled" }}
                template(v-else) This switch is {{ toggle.value ? "enabled" : "disabled" }}
        .row.justify-content-center.b-param-container
          BaseParamToggle.col-12.col-sm-6(:value='false' :inEdit='state !== 0'
                                          title="Toggle Param (false)" required
                                          ref='invalid' @edit='$refs.invalid.checkValidity()')
          BaseParamToggle.col-12.col-sm-6(:value='true' :inEdit='state !== 0'
                                          ref='valid' title="Toggle Param (true)" required
                                          @edit='$refs.valid.checkValidity()'
                                          @edit-request='state = state ? 0 : 1')
            template(#trueIcon='') \#[i.fas.fa-check-circle]
            template(#falseIcon='') \#[i.fas.fa-times-circle]
            template(#label='') custom toggle
</template>
<script>

import Example from "./AppExample.vue";

export default {
  name: "ExampleToggle",
  components: { Example }
};

</script>
